/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CButton.h
  Info   : $Id: CButton.h,v 1.3 2005/02/16 20:22:17 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CButton_h
#define CButton_h

// cxxx headers
#include <cxxx/CTopLevelWindow.h>

class CButton : public CWindow
{
public:
	CButton(CWindow *parent, unsigned msgid, bool show = true);
	virtual ~CButton();
	virtual void OnExpose(XExposeEvent& e) = 0;
	virtual void SetName(const std::string& name);
	virtual void OnFocus(bool in);
	virtual void OnAccelerator(unsigned key);
	virtual void Enable(bool enable);
	bool IsFocused();
protected:
	virtual void UpdateState();
	std::string mName;
	bool mFocused;
	unsigned mAccelerator;
	std::string::size_type mHotCharPos;
};

inline void CButton::Enable(bool enable)
{
	if (IsEnabled() == enable) return ;
	CWindow::Enable(enable);
	SetFocusable(enable);
	if (!IsEnabled() && mFocused == true) GetTopLevelWindow()->SetFocusWindow(NULL);
	Redraw();
}

inline bool CButton::IsFocused()
{
	return mFocused;
}

#endif // CButton_h












