/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CCheckButton.h
  Info   : $Id: CCheckButton.h,v 1.3 2005/02/16 20:22:27 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CCheckButton_h
#define CCheckButton_h

// cxxx headers
#include <cxxx/CButton.h>

class CCheckButton : public CButton
{
public:
	CCheckButton(CWindow* parent, unsigned msgid, bool show = true);
	virtual ~CCheckButton();
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnLButtonDown(XButtonEvent& e);
	virtual void SetName(const std::string& name);
	virtual void OnFocus(bool in);
	virtual void OnAccelerator(unsigned key);
	void SetCheck(bool check);
	bool IsChecked();
protected:
	virtual void UpdateState();
    void ToggleCheck();
	void DrawFocusRect();
	bool mChecked;
	CIcon mCheck;
};

inline void CCheckButton::SetCheck(bool check)
{
	if (mChecked == check) return ;
	mChecked = check;
	UpdateState();
}

inline bool CCheckButton::IsChecked()
{
	return mChecked;
}

#endif // CCheckButton_h



