/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CColorSheet.h
  Info   : $Id: CColorSheet.h,v 1.5 2006/12/09 19:13:02 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2005, 2006 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CColorSheet_h
#define CColorSheet_h

// cxxx headers
#include <cxxx/CPushButton.h>

// C++ headers

// optional headers

class CColorSheet : public CWindow
{
private:
	enum
	{
		IDFRAME = cxxx::msgid::MSGID_CColorSheet,
		IDTITLE,
		IDTOOL,
		IDBACK
	};
public:
    CColorSheet(CWindow* parent);
	virtual ~CColorSheet();
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	bool DoOK();
protected:
	void DrawColorRect(int x, int y, unsigned w, unsigned h, const CColor& col, const std::string& s);
protected:
	CColor mFrameColor;
	CColor mTitleColor;
	CColor mTooltipColor;
	CColor mBackgroundColor;
	CPushButton mFrameChoose;
	CPushButton mTitleChoose;
	CPushButton mTooltipChoose;
	CPushButton mBackgroundChoose;
};

inline void CColorSheet::DrawColorRect(int x, int y, unsigned w, unsigned h, const CColor& col, const std::string& s)
{
	DrawFrame(x, y, w, h, SUNKEN_THICK, false);
	GC gc = cxxx::cxGCManager->GetDefaultGC();
	XGCValues gcv;
	gcv.clip_mask = None;
	gcv.foreground = col.GetPixel();
	XChangeGC(cxxx::cxDpy, gc, GCClipMask | GCForeground, &gcv);
	SetGC(CGC::DEFAULT);
	FillRectangle(x + 2, y + 2, w - 4, h - 4);
	if (col.GetLuminance() >= 0x80) SetGC(CGC::BLACK);
	else SetGC(CGC::WHITE);
	DrawString(x + 7, y + (h - GetTextHeight()) / 2, s, false);
}

#endif // CColorSheet_h
