/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CDropDownPopup.h
  Info   : $Id: CDropDownPopup.h,v 1.7 2007/06/30 23:15:08 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2007 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CDropDownPopup_h
#define CDropDownPopup_h

// cxxx headers
#include <cxxx/CScrollBar.h>

class CDropDownPopup : public CWindow
{
private:
	enum
	{
		IDSCROLL = cxxx::msgid::MSGID_CDropDownPopup
	};
public:
	CDropDownPopup(CWindow* parent, unsigned msgid, const std::vector<std::string>& list);
	~CDropDownPopup();
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnLButtonDown(XButtonEvent& e);
	virtual void OnButtonUp(XButtonEvent& e);
	virtual void OnEvent(XEvent& e);
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	virtual void Recolor();
	void Position(int x, int y, int w, int h);
	void Select(unsigned idx);
protected:
	void DrawItem(unsigned idx, bool selected);
	unsigned GetItemFromPos(int x, int y);
	const std::vector<std::string>& mList;
	unsigned mSelected;
	unsigned mOffset;
	Cursor mCursor;
	bool mScrolling;
	CVScrollBar mScrollbar;
};

#endif // CDropDownPopup_h
