/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CDupFNDialog.h
  Info   : $Id: CDupFNDialog.h,v 1.4 2006/01/29 12:55:35 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2006 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CDupFNDialog_h
#define CDupFNDialog_h

// cxxx headers
#include <cxxx/CEdit.h>
#include <cxxx/CPushButton.h>
#include <cxxx/CRadioGroup.h>
#include <cxxx/CRadioButton.h>
#include <cxxx/CLabel.h>

class CDupFNDialog : public CTopLevelWindow
{
public:
	enum {
	    IDRENAME = cxxx::msgid::MSGID_CDupFNDialog,
	    IDSKIP,
	    IDAUTOSKIP,
	    IDOVER,
	    IDOVERALL,
		IDOK,
	    IDCANCEL
	};
	CDupFNDialog(const std::string& path, const std::string& name);
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	virtual void OnFocus(bool in);
	virtual void OnKey(unsigned key, unsigned state);
	virtual void OnQuit();
	virtual ~CDupFNDialog();
	const std::string& GetName();
private:
	CLabel mStatic;
	CEdit mEdit;
	CIcon mIcon;
	CRadioGroup mAction;
	CRadioButton mRename;
	CRadioButton mSkip;
	CRadioButton mAutoSkip;
	CRadioButton mOver;
	CRadioButton mOverAll;
	CPushButton mOK;
	CPushButton mCancel;
	std::string mPath;
	std::string mName;
};

#endif // CDupFNDialog_h
