/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CLabel.h
  Info   : $Id: CLabel.h,v 1.3 2005/02/16 20:22:36 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CLabel_h
#define CLabel_h

// cxxx headers
#include <cxxx/CWindow.h>

class CLabel : public CWindow
{
public:
	CLabel(CWindow* mParent, bool show = true);
	virtual ~CLabel();
	virtual void OnExpose(XExposeEvent& e);
	void SetText(const std::string& text);
	const std::string& GetText();
protected:
	std::string mText;
};

inline void CLabel::SetText(const std::string& text)
{
	mText = text;
	Redraw();
}

inline const std::string& CLabel::GetText()
{
	return mText;
}

#endif // CLabel_h




