/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CMenuBar.h
  Info   : $Id: CMenuBar.h,v 1.3 2005/02/16 20:22:38 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CMenuBar_h
#define CMenuBar_h

#include <cxxx/CWindow.h>
#include <cxxx/CMenuItem.h>

class CPopup;

class CMenuBar : public CWindow
{
public:
	CMenuBar(CWindow* parent, bool show = true);
	virtual ~CMenuBar();
	//
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnLButtonDown(XButtonEvent& e);
	virtual void OnEvent(XEvent& event);
	virtual void OnFocus(bool in);
	virtual void OnAccelerator(unsigned key);
	void AddMenu(CMenu& m);
	void Check(unsigned msgid);
	void Uncheck(unsigned msgid);
	bool IsSelected();
protected:
	void Select(unsigned idx);
	int CalculatePosition(unsigned idx);
	unsigned GetItemFromPos(int x);
	std::vector<CMenu> mMenu;
	unsigned mSelected;
};

inline bool CMenuBar::IsSelected()
{
	return mSelected != -1u;
}

inline void CMenuBar::Check(unsigned msgid)
{
	for (std::vector<CMenu>::iterator i = mMenu.begin(); i < mMenu.end(); ++i) i->Check(msgid);
}

inline void CMenuBar::Uncheck(unsigned msgid)
{
	for (std::vector<CMenu>::iterator i = mMenu.begin(); i < mMenu.end(); ++i) i->Uncheck(msgid);
}

#endif // CMenuBar_h















