/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CMessageBox.h
  Info   : $Id: CMessageBox.h,v 1.4 2005/02/16 20:22:41 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CMessageBox_h
#define CMessageBox_h


// cxxx headers
#include <cxxx/CLabel.h>
#include <cxxx/CTopLevelWindow.h>
#include <string>

#define MESSAGEBOX_SIZE_X 280
#define MESSAGEBOX_SIZE_Y 120

class CPushButton;
class CLabel;

class CMessageBox : public CTopLevelWindow
{
public:
//messagebox styles
    enum
    {
        OK = 0x01,
        YES = 0x02,
        NO = 0x04,
        RETRY = 0x08,
        IGNORE = 0x10,
        CANCEL = 0x20
    };
private:
	enum
	{
		IDOK = cxxx::msgid::MSGID_CMessageBox,
		IDYES,
		IDNO,
		IDRETRY,
		IDIGNORE,
		IDCANCEL
	};
public:
    CMessageBox(const std::string& text, const std::string& caption, unsigned style, const std::string& icon);
	virtual ~CMessageBox();
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	virtual void OnQuit();
	virtual void OnKey(unsigned key, unsigned state);
	virtual void OnExpose(XExposeEvent& e);
	void FocusButton(unsigned i);
protected:
	CIcon mIcon;
	CLabel mText;
	CPushButton* mButton[3];
	unsigned mButtonID[3];
    unsigned mCount;
};

#endif // CMessageBox_h















