/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CPopup.h
  Info   : $Id: CPopup.h,v 1.3 2005/02/16 20:22:41 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CPopup_h
#define CPopup_h

// cxxx headers
#include <cxxx/CWindow.h>
#include <cxxx/CMenuItem.h>

// forward declarations
class CMenuBar;
class CTopLevelWindow;

class CPopup : public CWindow
{
	enum
	{
		IDTIMER = cxxx::msgid::MSGID_CPopup
	};
private:
    enum
    {
        BORDER_WIDTH = 24,
        BORDER_HEIGHT = 4,
        SPACE = 4,
        ARROW_WIDTH = 16,
        ICON_WIDTH = 20
    };
public:
    enum
    {
        DOWN,
        LEFT,
        RIGHT
    };

public:
	CPopup(CWindow* w, CMenu& m);
	virtual ~CPopup();
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnLButtonDown(XButtonEvent& e);
	virtual void OnButtonUp(XButtonEvent& e);
	virtual void OnEvent(XEvent& e);
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	virtual void OnAccelerator(unsigned key);
	void DrawMenu(unsigned idx, bool selected);
	void Position(int x, int y, int w, int h, unsigned ph);
	void Select(unsigned i);
protected:
	unsigned GetItemFromPos(int pos);
	int CalculatePosition(unsigned idx);
	CMenu& mMenu;
	unsigned mSelected;
	unsigned mTextWidth;
	int mTextYPos;
	unsigned mPosHint;
	Cursor mCursor;
	CIcon mArrow;
	CIcon mBullet;
	CIcon mCheck;
	CTimer mTimer;
	CPopup* mChild;
};

#endif // CPopup_h

