/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CRadioGroup.h
  Info   : $Id: CRadioGroup.h,v 1.3 2005/02/16 20:22:57 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CRadioGroup_h
#define CRadioGroup_h

// cxxx headers
#include <cxxx/CMessageTransceiver.h>
#include <cxxx/CRadioButton.h>

// forward declarations
class CWindow;

class CRadioGroup
{
public:
    CRadioGroup(CWindow* parent);
	~CRadioGroup();
	void Register(CRadioButton* b);
	void Unregister(CRadioButton* b);
	CWindow* GetParent();
	void OnCheck(CRadioButton* b);
protected:
	std::vector<CRadioButton*> mButtonArray ;
	CRadioButton* mSelection;
	CWindow* mParent;
};

inline void CRadioGroup::Register(CRadioButton* b)
{
	mButtonArray.push_back(b);
    mSelection = NULL;
}

inline void CRadioGroup::Unregister(CRadioButton *b)
{
	std::vector<CRadioButton*>::iterator i = find(mButtonArray.begin(), mButtonArray.end(), b);
    assert(i != mButtonArray.end());
    mButtonArray.erase(i);
    mSelection = NULL;
}

inline CWindow* CRadioGroup::GetParent()
{
	return mParent;
}

#endif // CRadioGroup_h



