/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CTimingSheet.h
  Info   : $Id: CTimingSheet.h,v 1.4 2005/09/17 20:04:21 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CTimingSheet_h
#define CTimingSheet_h

// cxxx headers
#include <cxxx/CSlider.h>
#include <cxxx/CNumEdit.h>
#include <cxxx/CCheckButton.h>

// C++ headers

// optional headers

class CTimingSheet : public CWindow
{
private:
	enum
	{
		IDDBL_CLICK = cxxx::msgid::MSGID_CTimingSheet,
		IDDBL_CLICK_EDIT,
		IDDELAY,
		IDDELAY_EDIT,
		IDDELAY_ENABLE
	};
public:
    CTimingSheet(CWindow* parent);
	virtual ~CTimingSheet();
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	bool DoOK();
	unsigned GetDblClickTime();
	unsigned GetToolTipTime();
protected:
	CSlider mDblClick;
	CSlider mDelay;
	CNumEdit mDblClickEdit;
	CNumEdit mDelayEdit;
	CCheckButton mDelayEnable;
};

inline unsigned CTimingSheet::GetDblClickTime()
{
	return mDblClickEdit.GetValue();
}

inline unsigned CTimingSheet::GetToolTipTime()
{
	if (mDelayEnable.IsChecked()) return mDelayEdit.GetValue();
	else return 0;
}

#endif // CTimingSheet_h
