/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CToolButton.h
  Info   : $Id: CToolButton.h,v 1.5 2005/09/17 20:04:21 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2005 Gerhard Kräuter <gkraeuter@users.sourceforge.net>
  
  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CToolButton_h
#define CToolButton_h

#define TOOLBUTTON_SIZE_X 22
#define TOOLBUTTON_SIZE_Y 22

// cxxx headers
#include <cxxx/CWindow.h>

class CToolTip;

class CToolButton : public CWindow
{
enum
{
	IDTIMER = cxxx::msgid::MSGID_CToolButton
};
public:
	CToolButton(CWindow* parent, unsigned msgid, const std::string& icon, const std::string& tip);
	virtual ~CToolButton();
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnLButtonDown(XButtonEvent& e);
	virtual void OnButtonUp(XButtonEvent& e);
	virtual void OnEvent(XEvent& e);
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
	void Update();
	void CloseToolTip();
	void OpenToolTip();
	static void SetDelay(unsigned d);
	static unsigned GetDelay();
protected:
	CIcon mIcon;
	CToolTip* mToolTip;
	std::string mToolTipText;
	bool mPressed;
	CTimer mTimer;
	static unsigned mDelay;
};

inline void CToolButton::Update()
{
	if (GetUpdate() == IsEnabled()) return ;
	Enable(!IsEnabled());
	Redraw();
}

inline void CToolButton::SetDelay(unsigned d)
{
	mDelay = d;
}

inline unsigned CToolButton::GetDelay()
{
	return mDelay;
}

#endif // CToolButton_h
